#pragma once

// STD/STL
#include <string>

// Navigation
#include <armarx/navigation/client/NavigationStackConfig.h>
#include <armarx/navigation/components/Navigator/NavigatorInterface.h>
#include <armarx/navigation/core/NavigatorInterface.h>

namespace armarx::navigation::client
{

    class IceNavigator : virtual public core::NavigatorInterface
    {

    public:
        IceNavigator();

        ~IceNavigator() override;

        void setNavigatorComponent(const components::NavigatorInterfacePrx& navigator);

        void createConfig(const client::NavigationStackConfig& config, const std::string& configId);

        void moveTo(const std::vector<core::Pose>& waypoints,
                    core::NavigationFrame navigationFrame);

        void moveTowards(const core::Direction& direction, core::NavigationFrame navigationFrame);

        void pause();

        void resume();

        void stop();

        bool isPaused() const noexcept;

        bool isStopped() const noexcept;

    private:
        std::string configId;

        components::NavigatorInterfacePrx navigator;
    };

} // namespace armarx::navigation::client
